package com.maroontress.coverture;

import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.LinkedList;
import java.util.Queue;
import java.util.TreeMap;

/**
   ؿդΥΡɤȤʤܥ֥åǤ
*/
public final class Block {

    /** ֥åμ̻ҤǤ */
    private int id;

    /** ֥åΥե饰Ǥ */
    private int flags;

    /** 륢פΥꥹȤǤ */
    private ArrayList<Arc> inArcs;

    /** ¹ԲȽ륢פνǤ */
    private LinkedList<Arc> solvedInArcs;

    /** ¹Բʡ륢פνǤ */
    private LinkedList<Arc> unsolvedInArcs;

    /** ֽФ륢פΥꥹȤǤ */
    private ArrayList<Arc> outArcs;

    /** ¹ԲȽֽФ륢פΥꥹȤǤ */
    private LinkedList<Arc> solvedOutArcs;

    /** ¹ԲʡֽФ륢פΥꥹȤǤ */
    private LinkedList<Arc> unsolvedOutArcs;

    /** ֥åμ¹ԲǤ */
    private long count;

    /**
       Block is a call instrumenting site; does the call: ؿƤӽ
       ֥åǤ뤳Ȥ򼨤ޤ
    */
    private boolean callSite;

    /**
       Block is a call instrumenting site; is the return. ƤӽФ
       Ȥʤ֥åǤ뤳Ȥ򼨤ޤ
    */
    private boolean callReturn;

    /**
       Block is a landing pad for longjmp or throw: ν
       catchޤsetjmp()Ǥ뤳Ȥ򼨤ޤ
    */
    private boolean nonLocalReturn;

    /** ֥åб륽ɤιԥȥǤ */
    private LineEntry[] lines;

    /**
       ֹμ¹Բ򥽡ꥹȤ˥ޡޤ

       ˼¹ԲΥȤͭˤʤäƤɬפޤ

       @param sourceList ꥹ
    */
    public void addLineCounts(final SourceList sourceList) {
	assert(count >= 0);
	if (lines == null) {
	    return;
	}
	// forLineEntry˰ܤ...
	// e.addLineCounts(sourcelist, count);
	for (LineEntry e : lines) {
	    String fileName = e.getFileName();
	    int[] nums = e.getLines();
	    if (nums.length == 0) {
		continue;
	    }
	    Source source = sourceList.getSource(fileName);
	    for (int k = 0; k < nums.length; ++k) {
		source.addLineCount(nums[k], count);
	    }
	}
    }

    /**
       ȤޤȤͭǤʤȤ0֤ޤ

       @return 
    */
    public long getCount() {
	return (count < 0) ? 0 : count;
    }

    /**
       Ȥͭޤ

       @return ȤͭʤtrueǤʤfalse
    */
    public boolean getCountValid() {
	return (count >= 0);
    }

    /**
       ¹Գޤ

       @param c ¹Բ
       @return ¹Գ
    */
    private double getRate(final long c) {
	return (count == 0) ? 0 : 100.0 * c / count;
    }

    /**
       XMLǥ֥åϤޤ

       @param out 
    */
    public void printXML(final PrintWriter out) {
	final boolean countValid = getCountValid();

	out.printf("<block id='%d' flags='0x%x' callSite='%b' "
		   + "callReturn='%b' nonLocalReturn='%b'",
		   id, flags, callSite, callReturn, nonLocalReturn);
	if (countValid) {
	    out.printf(" count='%d'", count);
	}
	out.printf(">\n");

	for (Arc arc : outArcs) {
	    out.printf("<arc destination='%d' fake='%b' onTree='%b' "
		       + "fallThrough='%b' callNonReturn='%b' "
		       + "nonLocalReturn='%b' unconditional='%b'",
		       arc.getEnd().getId(), arc.isFake(), arc.isOnTree(),
		       arc.isFallThrough(), arc.isCallNonReturn(),
		       arc.isNonLocalReturn(), arc.isUnconditional());
	    if (countValid) {
		long c = arc.getCount();
		out.printf(" count='%d' rate='%.2f'", c, getRate(c));
	    }
	    out.printf("/>\n");
	}
	if (lines != null) {
	    // forLineEntry˰ܤ...
	    // e.printXML();
	    for (LineEntry e : lines) {
		String fileName = e.getFileName();
		int[] nums = e.getLines();
		if (nums.length == 0) {
		    continue;
		}
		out.printf("<lines fileName='%s'>\n", XML.escape(fileName));
		for (int k = 0; k < nums.length; ++k) {
		    out.printf("<line number='%d' />\n", nums[k]);
		}
		out.printf("</lines>\n");
	    }
	}
	out.printf("</block>\n");
    }

    /**
       ֥åޤ

       @param id ֥åμ̻
       @param flags ֥åΥե饰
    */
    public Block(final int id, final int flags) {
	this.id = id;
	this.flags = flags;
	this.count = -1;
	inArcs = new ArrayList<Arc>();
	solvedInArcs = new LinkedList<Arc>();
	unsolvedInArcs = new LinkedList<Arc>();
	outArcs = new ArrayList<Arc>();
	solvedOutArcs = new LinkedList<Arc>();
	unsolvedOutArcs = new LinkedList<Arc>();
    }

    /**
       ؿƤӽФ֥åɤꤷޤ

       @param b ؿƤӽФ֥åξtrueǤʤ
       false
    */
    public void setCallSite(final boolean b) {
	callSite = b;
    }

    /**
       catchޤsetjmp()ޤ֥åɤꤷޤ

       @param b catchޤsetjmp()ޤ֥åξtrue
       ʤfalse
    */
    public void setNonLocalReturn(final boolean b) {
	nonLocalReturn = b;
    }

    /**
       Υ֥å˥ɲäޤ

       @param arcs Υꥹ
       @param unsolvedArcs ¹Բʥν
       @param solvedArcs ¹ԲȽ륢ν
       @param arc 
    */
    private void addArc(final ArrayList<Arc> arcs,
			final LinkedList<Arc> unsolvedArcs,
			final LinkedList<Arc> solvedArcs,
			final Arc arc) {
	arcs.add(arc);
	if (arc.isOnTree()) {
	    unsolvedArcs.add(arc);
	} else {
	    solvedArcs.add(arc);
	}
    }

    /**
       Υ֥å륢ɲäޤ

       @param arc 
    */
    public void addInArc(final Arc arc) {
	addArc(inArcs, unsolvedInArcs, solvedInArcs, arc);
    }

    /**
       Υ֥åФ륢ɲäޤ

       @param arc 
    */
    public void addOutArc(final Arc arc) {
	addArc(outArcs, unsolvedOutArcs, solvedOutArcs, arc);
    }

    /**
       Υ֥åιԥȥꤷޤ

       @param lines ԥȥ
    */
    public void setLines(final LineEntry[] lines) {
	this.lines = lines;
    }

    /**
       ̻Ҥޤ

       @return ̻
    */
    public int getId() {
	return id;
    }

    /**
       륢פΥꥹȤޤ

       @return 륢פΥꥹ
    */
    public ArrayList<Arc> getInArcs() {
	return inArcs;
    }

    /**
       ֽФ륢פΥꥹȤޤ

       @return ֽФ륢פΥꥹ
    */
    public ArrayList<Arc> getOutArcs() {
	return outArcs;
    }

    /**
       ؿƤӽФ֥åɤޤ

       @return ؿƤӽФ֥åξtrueǤʤfalse
    */
    public boolean isCallSite() {
	return callSite;
    }

    /**
       եդ򤯤ν򤷤ޤ

       ֥åФ뵶Ǥʤ1Ĥʤ硢Υ̵
       ʬꤷޤˡΥ֥åָƤ
       ФפǤ뤫ɤꤷޤ
    */
    public void presolve() {
	int nonFakeArcs = 0;
	Arc lastNonFakeArc = null;

	for (Arc a : outArcs) {
	    if (!a.isFake()) {
		lastNonFakeArc = a;
		++nonFakeArcs;
	    }
	}
	if (nonFakeArcs != 1) {
	    return;
	}
	Arc arc = lastNonFakeArc;
	Block destBlock = arc.getEnd();
	/*
	  If there is only one non-fake exit, it is an unconditional
	  branch.
	*/
	arc.setUnconditional(true);
	/*
	  If this block is instrumenting a call, it might be an
	  artificial block. It is not artificial if it has a
	  non-fallthrough exit, or the destination of this arc has
	  more than one entry.  Mark the destination block as a return
	  site, if none of those conditions hold.
	*/
	if (callSite
	    && arc.isFallThrough()
	    && destBlock.inArcs.get(0) == arc
	    && destBlock.inArcs.size() == 1) {
	    destBlock.callReturn = true;
	}
    }

    /**
       ֽФ륢פΥꥹȤ򤽤νλ֥åμ̻ҽ˥Ȥ롣
    */
    public void sortOutArcs() {
	TreeMap<Integer, Arc> map = new TreeMap<Integer, Arc>();
	for (Arc a : outArcs) {
	    map.put(a.getEnd().id, a);
	}
	outArcs.clear();
	outArcs.addAll(map.values());
    }

    /**
       ν礫¹Բޤ

       @param arcs ν
       @return ¹Բ
    */
    private long sumCount(final Collection<Arc> arcs) {
	long total = 0;
	for (Arc a : arcs) {
	    total += a.getCount();
	}
	return total;
    }

    /**
       ¹Բޤ

       @param arcs Υꥹ
       @param unsolvedArcs ¹ԲʥΥꥹ
       @return ¹ԲޤätrueǤʤfalse
    */
    private boolean validateCount(final ArrayList<Arc> arcs,
				  final LinkedList<Arc> unsolvedArcs) {
	if (arcs.size() > 0 && unsolvedArcs.size() == 0) {
	    count = sumCount(arcs);
	    return true;
	}
	return false;
    }

    /**
       ¹Բޤ

       륢פμ¹Բ٤ƵޤäƤ뤫ֽФ륢
       μ¹Բ٤ƵޤäƤ硢¤֥åμ
       ԲȤƷ׻֥å򥭥塼ɲäޤ

       륢פȡֽФ륢פΤɤ¹ԲޤäƤ
       ϲ⤷ޤ

       @param q ¹ԲޤäȤ˥֥åɲä륭塼
    */
    public void validate(final Queue<Block> q) {
	if (validateCount(inArcs, unsolvedInArcs)
	    || validateCount(outArcs, unsolvedOutArcs)) {
	    q.add(this);
	}
    }

    /**
       ֽФ륢פμ¹ԲȽȤ˸ƤӽФޤ

       ֥åμ¹ԲȽƤϡ֥åֽФ
       פΤ¹ԲȽƤʤμ¹Բǽ
       ʤޤ

       ֥åμ¹Բʾϡ֥åμ¹Բǽʤ
       ޤޤäϥ֥å򥭥塼ɲäޤ

       @param q ¹ԲȽȤ˥֥åɲä륭塼
       @param arc ¹ԲȽ
    */
    private void validateInSideBlock(final Queue<Block> q, final Arc arc) {
	unsolvedOutArcs.remove(arc);
	solvedOutArcs.add(arc);
	if (inArcs.size() > 0 && unsolvedInArcs.size() == 0) {
	    // ˼¹ԲȽƤ
	    if (unsolvedOutArcs.size() == 1) {
		validateOutSide(q);
	    }
	} else {
	    // ޤ¹Բ
	    if (validateCount(outArcs, unsolvedOutArcs)) {
		q.add(this);
	    }
	}
    }

    /**
       ¹Բʡ륢פ1ĤǤꡢĥ֥åμ
       ԲȽȤ˸ƤӽФ졢٤ƤΡ륢פμ¹
       Ƚޤ

       ¹ԲȽγϥ֥åˤĤơƵŪ˼¹Բ
       ޤ

       @param q ¹ԲȽȤ˥֥åɲä륭塼
    */
    private void validateInSide(final Queue<Block> q) {
	Arc arc = unsolvedInArcs.remove();
	arc.setCount(count - sumCount(solvedInArcs));
	solvedInArcs.add(arc);
	// arcФ֥åˤĤƤν
	arc.getStart().validateInSideBlock(q, arc);
    }

    /**
       륢פμ¹ԲȽȤ˸ƤӽФޤ

       ֥åμ¹ԲȽƤϡ֥åˡ륢
       פΤ¹ԲȽƤʤμ¹Բǽʤ
       ޤ

       ֥åμ¹Բʾϡ֥åμ¹Բǽʤ
       ޤޤäϥ֥å򥭥塼ɲäޤ

       @param q ¹ԲȽȤ˥֥åɲä륭塼
       @param arc ¹ԲȽ
    */
    private void validateOutSideBlock(final Queue<Block> q, final Arc arc) {
	unsolvedInArcs.remove(arc);
	solvedInArcs.add(arc);
	if (outArcs.size() > 0 && unsolvedOutArcs.size() == 0) {
	    // ˼¹ԲȽƤ
	    if (unsolvedInArcs.size() == 1) {
		validateInSide(q);
	    }
	} else {
	    // ޤ¹Բ
	    if (validateCount(inArcs, unsolvedInArcs)) {
		q.add(this);
	    }
	}
    }

    /**
       ¹ԲʡֽФ륢פ1ĤǤꡢĥ֥åμ
       ԲȽȤ˸ƤӽФ졢٤ƤΡֽФ륢פμ¹
       Ƚޤ

       ¹ԲȽνλ֥åˤĤơƵŪ˼¹Բ
       ޤ

       @param q ¹ԲȽȤ˥֥åɲä륭塼
    */
    private void validateOutSide(final Queue<Block> q) {
	Arc arc = unsolvedOutArcs.remove();
	arc.setCount(count - sumCount(solvedOutArcs));
	solvedOutArcs.add(arc);
	// arc֥åˤĤƤν
	arc.getEnd().validateOutSideBlock(q, arc);
    }

    /**
       ֥å륢Ф륢줾ˤĤơ¹Բ
       ʤΤ1Ĥʤ顢μ¹Բޤ

       ֥åϴ˼¹ԲȽƤɬפޤ

       @param q ¹ԲȽȤ˥֥åɲä륭塼
    */
    public void validateSides(final Queue<Block> q) {
	if (unsolvedInArcs.size() == 1) {
	    validateInSide(q);
	}
	if (unsolvedOutArcs.size() == 1) {
	    validateOutSide(q);
	}
    }
}
